﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace AircraftCarrier
{
    internal class DrawningModernAircraftCarrier : DrawningAircraftCarrier
    {
        public DrawningModernAircraftCarrier(int speed, float weight, Color bodyColor, Color
dopColor, bool flightDeck, bool hangarDeck, bool route) :
 base(speed, weight, bodyColor, 230, 80)
        {
            AircraftCarrier = new EntityModernAircraftCarrier(speed, weight, bodyColor, dopColor, flightDeck, hangarDeck, route);
        }
        public override void DrawTransport(Graphics g)
        {
            if (AircraftCarrier is not EntityModernAircraftCarrier modernAircraftCarrier)
            {
                return;
            }
            Pen pen = new(Color.Black);
            Brush dopBrush = new SolidBrush(modernAircraftCarrier.DopColor);
            if (modernAircraftCarrier.FlightDeck)
            {
                g.DrawRectangle(pen, _startPosX + 10, _startPosY, 160, 10);
                g.DrawRectangle(pen, _startPosX + 10, _startPosY + 70, 160, 10);
                g.FillRectangle(dopBrush, _startPosX + 10, _startPosY, 160, 10);
                g.FillRectangle(dopBrush, _startPosX + 10, _startPosY + 70, 160, 10);
            }
            base.DrawTransport(g);
            if (modernAircraftCarrier.HangarDeck)
            {
                g.DrawRectangle(pen, _startPosX + 20, _startPosY + 24, 20, 30);
                g.FillRectangle(dopBrush, _startPosX + 20, _startPosY + 24, 20, 30);
            }
            if (modernAircraftCarrier.Route)
            {
                g.DrawRectangle(pen, _startPosX, _startPosY + 14, 10, 5);
                g.DrawRectangle(pen, _startPosX, _startPosY + 69, 10, 5);
                g.FillRectangle(dopBrush, _startPosX, _startPosY + 14, 10, 5);
                g.FillRectangle(dopBrush, _startPosX, _startPosY + 69, 10, 5);
            }
        }
    }
}