﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace AircraftCarrier
{
    internal class DrawningObjectAircraftCarrier : IDrawningObject
    {
        private DrawningAircraftCarrier _aircraftcarrier = null;
        public DrawningObjectAircraftCarrier(DrawningAircraftCarrier aircraftcarrier)
        {
            _aircraftcarrier = aircraftcarrier;
        }
        public float Step => _aircraftcarrier?.AircraftCarrier?.Step ?? 0;
        public (float Left, float Right, float Top, float Bottom) GetCurrentPosition()
        {
            return _aircraftcarrier?.GetCurrentPosition() ?? default;
        }
        public void MoveObject(Direction direction)
        {
            _aircraftcarrier?.MoveTransport(direction);
        }
        public void SetObject(int x, int y, int width, int height)
        {
            _aircraftcarrier.SetPosition(x, y, width, height);
        }
        public void DrawningObject(Graphics g)
        {
            _aircraftcarrier.DrawTransport(g);
        }
        public string GetInfo() => _aircraftcarrier?.GetDataForSave();
        public static IDrawningObject Create(string data) => new DrawningObjectAircraftCarrier(data.CreateDrawningAircraftCarrier());
    }
}