﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace AircraftCarrier
{
    internal static class ExtentionAircraftCarrier
    {
        private static readonly char _separatorForObject = ':';
        public static DrawningAircraftCarrier CreateDrawningAircraftCarrier(this string info)
        {
            string[] strs = info.Split(_separatorForObject);
            if (strs.Length == 3)
            {
                return new DrawningAircraftCarrier(Convert.ToInt32(strs[0]),
                Convert.ToInt32(strs[1]), Color.FromName(strs[2]));
            }
            if (strs.Length == 7)
            {
                return new DrawningModernAircraftCarrier(Convert.ToInt32(strs[0]),
                Convert.ToInt32(strs[1]), Color.FromName(strs[2]),
                Color.FromName(strs[3]), Convert.ToBoolean(strs[4]),
               Convert.ToBoolean(strs[5]), Convert.ToBoolean(strs[6]));
            }
            return null;
        }
        public static string GetDataForSave(this DrawningAircraftCarrier drawningAircraftCarrier)
        {
            var aircraftcarrier = drawningAircraftCarrier.AircraftCarrier;
            var str =
           $"{aircraftcarrier.Speed}{_separatorForObject}{aircraftcarrier.Weight}{_separatorForObject}{aircraftcarrier.BodyColor.Name}";
            if (aircraftcarrier is not EntityModernAircraftCarrier modernAircraftCarrier)
            {
                return str;
            }
            return
           $"{str}{_separatorForObject}{modernAircraftCarrier.DopColor.Name}{_separatorForObject}{modernAircraftCarrier.FlightDeck}{_separatorForObject}{modernAircraftCarrier.HangarDeck}{_separatorForObject}{modernAircraftCarrier.Route}";
        }
    }
}