﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace AircraftCarrier
{
    public partial class FormAircraftCarrier : Form
    {
        private DrawningAircraftCarrier _aircraftcarrier;
        public DrawningAircraftCarrier SelectedAircraftCarrier { get; private set; }
        public FormAircraftCarrier()
        {
            InitializeComponent();
        }
        private void Draw()
        {
            Bitmap bmp = new Bitmap(pictureBoxAircraftCarrier.Width, pictureBoxAircraftCarrier.Height);
            Graphics gr = Graphics.FromImage(bmp);
            _aircraftcarrier?.DrawTransport(gr);
            pictureBoxAircraftCarrier.Image = bmp;
        }
        private void SetData()
        {
            Random rnd = new();
            _aircraftcarrier.SetPosition(rnd.Next(10, 30), rnd.Next(10, 30),
           pictureBoxAircraftCarrier.Width, pictureBoxAircraftCarrier.Height);
            toolStripStatusLabelSpeed.Text = $"Скорость: {_aircraftcarrier.AircraftCarrier.Speed}";
            toolStripStatusLabelWeight.Text = $"Вес: {_aircraftcarrier.AircraftCarrier.Weight}";
            toolStripStatusLabelBodyColor.Text = $"Цвет: {_aircraftcarrier.AircraftCarrier.BodyColor.Name}";
        }
        private void ButtonCreate_Click(object sender, EventArgs e)
        {
            Random rnd = new Random();
            Color color = Color.FromArgb(rnd.Next(0, 256), rnd.Next(0, 256), rnd.Next(0, 256));
            ColorDialog dialog = new();
            if (dialog.ShowDialog() == DialogResult.OK)
            {
                color = dialog.Color;
            }
            _aircraftcarrier = new DrawningAircraftCarrier(rnd.Next(100, 300), rnd.Next(4000, 5000), color);
            SetData();
            Draw();
        }
        private void ButtonMove_Click(object sender, EventArgs e)
        {
            string name = ((Button)sender)?.Name ?? string.Empty;
            switch (name)
            {
                case "buttonUp":
                    _aircraftcarrier?.MoveTransport(Direction.Up);
                    break;
                case "buttonDown":
                    _aircraftcarrier?.MoveTransport(Direction.Down);
                    break;
                case "buttonLeft":
                    _aircraftcarrier?.MoveTransport(Direction.Left);
                    break;
                case "buttonRight":
                    _aircraftcarrier?.MoveTransport(Direction.Right);
                    break;
            }
            Draw();
        }
        private void PictureBoxAircraftCarrier_Resize(object sender, EventArgs e)
        {
            /// Изменение размеров формы
            _aircraftcarrier?.ChangeBorders(pictureBoxAircraftCarrier.Width, pictureBoxAircraftCarrier.Height);
            Draw();
        }
        private void ButtonCreateModif_Click(object sender, EventArgs e)
        {
            Random rnd = new Random();
            Color color = Color.FromArgb(rnd.Next(0, 256), rnd.Next(0, 256), rnd.Next(0, 256));
            ColorDialog dialog = new();
            if (dialog.ShowDialog() == DialogResult.OK)
            {
                color = dialog.Color;
            }
            Color dopColor = Color.FromArgb(rnd.Next(0, 256), rnd.Next(0, 256), rnd.Next(0, 256));
            ColorDialog dialogDop = new();
            if (dialogDop.ShowDialog() == DialogResult.OK)
            {
                dopColor = dialogDop.Color;
            }
            _aircraftcarrier = new DrawningModernAircraftCarrier(rnd.Next(100, 300), rnd.Next(1000, 2000), color, dopColor,
            Convert.ToBoolean(rnd.Next(0, 2)), Convert.ToBoolean(rnd.Next(0, 2)), Convert.ToBoolean(rnd.Next(0, 2)));
            SetData();
            Draw();
        }
        private void ButtonSelectAircraftCarrier_Click(object sender, EventArgs e)
        {
            SelectedAircraftCarrier = _aircraftcarrier;
            DialogResult = DialogResult.OK;
        }
    }
}