﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace AircraftCarrier
{
    public partial class FormAircraftCarrierConfig : Form
    {
        DrawningAircraftCarrier _aircraftcarrier = null;
        private event Action<DrawningAircraftCarrier> EventAddAircraftCarrier;
        public FormAircraftCarrierConfig()
        {
            InitializeComponent();
            panelBlack.MouseDown += PanelColor_MouseDown;
            panelPurple.MouseDown += PanelColor_MouseDown;
            panelGrey.MouseDown += PanelColor_MouseDown;
            panelGreen.MouseDown += PanelColor_MouseDown;
            panelRed.MouseDown += PanelColor_MouseDown;
            panelWhite.MouseDown += PanelColor_MouseDown;
            panelYellow.MouseDown += PanelColor_MouseDown;
            panelBlue.MouseDown += PanelColor_MouseDown;
            // TODO buttonCancel.Click with lambda
            buttonCancel.Click += (sender, e) => Close();
        }
        private void DrawAircraftCarrier()
        {
            Bitmap bmp = new(pictureBoxObject.Width, pictureBoxObject.Height);
            Graphics gr = Graphics.FromImage(bmp);
            _aircraftcarrier?.SetPosition(5, 5, pictureBoxObject.Width,
           pictureBoxObject.Height);
            _aircraftcarrier?.DrawTransport(gr);
            pictureBoxObject.Image = bmp;
        }
        public void AddEvent(Action<DrawningAircraftCarrier> ev)
        {
            if (EventAddAircraftCarrier == null)
            {
                EventAddAircraftCarrier = new Action<DrawningAircraftCarrier>(ev);
            }
            else
            {
                EventAddAircraftCarrier += ev;
            }
        }
        private void LabelObject_MouseDown(object sender, MouseEventArgs e)
        {
            (sender as Label).DoDragDrop((sender as Label).Name, DragDropEffects.Move | DragDropEffects.Copy);
        }
        private void PanelObject_DragEnter(object sender, DragEventArgs e)
        {
            if (e.Data.GetDataPresent(DataFormats.Text))
            {
                e.Effect = DragDropEffects.Copy;
            }
            else
            {
                e.Effect = DragDropEffects.None;
            }
        }
        private void PanelObject_DragDrop(object sender, DragEventArgs e)
        {
            switch (e.Data.GetData(DataFormats.Text).ToString())
            {
                case "labelSimpleObject":
                    _aircraftcarrier = new DrawningAircraftCarrier((int)numericUpDownSpeed.Value,
                   (int)numericUpDownWeight.Value, Color.White);
                    break;
                case "labelModifiedObject":
                    _aircraftcarrier = new DrawningModernAircraftCarrier((int)numericUpDownSpeed.Value,
                   (int)numericUpDownWeight.Value, Color.White, Color.Black,
                    checkBoxFlightDeck.Checked, checkBoxHangarDeck.Checked,
                   checkBoxRoute.Checked);
                    break;
            }
            DrawAircraftCarrier();
        }
        private void LabelBaseColor_DragDrop(object sender, DragEventArgs e)
        {
            Color BaseColor = (Color)e.Data.GetData(typeof(Color));
            _aircraftcarrier.AircraftCarrier.BodyColor = BaseColor;
            DrawAircraftCarrier();
        }
        private void LabelBaseColor_DragEnter(object sender, DragEventArgs e)
        {
            if (e.Data.GetDataPresent(typeof(Color)))
            {
                e.Effect = DragDropEffects.Copy;
            }
            else
            {
                e.Effect = DragDropEffects.None;
            }
        }
        private void LabelDopColor_DragDrop(object sender, DragEventArgs e)
        {
            Color DopColor = (Color)e.Data.GetData(typeof(Color));
            if (_aircraftcarrier is DrawningModernAircraftCarrier _modernaircraftcarrier)
            {
                _modernaircraftcarrier.ReturnColor(DopColor);
                DrawAircraftCarrier();
            }
        }
        private void LabelDopColor_DragEnter(object sender, DragEventArgs e)
        {
            if (_aircraftcarrier is DrawningModernAircraftCarrier)
            {
                if (e.Data.GetDataPresent(typeof(Color)))
                {
                    e.Effect = DragDropEffects.Copy;
                }
                else
                {
                    e.Effect = DragDropEffects.None;
                }
            }
        }
        private void PanelColor_MouseDown(object sender, MouseEventArgs e)
        {
            (sender as Control).DoDragDrop((sender as Control).BackColor, DragDropEffects.Move | DragDropEffects.Copy);

        }
        private void ButtonOk_Click(object sender, EventArgs e)
        {
            EventAddAircraftCarrier?.Invoke(_aircraftcarrier);
            Close();
        }
    }
}