﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace AircraftCarrier
{
    public partial class FormMap : Form
    {
        private AbstractMap _abstractMap;
        public FormMap()
        {
            InitializeComponent();
            _abstractMap = new SimpleMap();
        }
        private void SetData(DrawningAircraftCarrier aircraftcarrier)
        {
            toolStripStatusLabelSpeed.Text = $"Скорость: {aircraftcarrier.AircraftCarrier.Speed}";
            toolStripStatusLabelWeight.Text = $"Вес: {aircraftcarrier.AircraftCarrier.Weight}";
            toolStripStatusLabelBodyColor.Text = $"Цвет: {aircraftcarrier.AircraftCarrier.BodyColor.Name}";
            PictureBoxAircraftCarrier.Image = _abstractMap.CreateMap(PictureBoxAircraftCarrier.Width, PictureBoxAircraftCarrier.Height, new DrawningObjectAircraftCarrier(aircraftcarrier));
        }
        private void ButtonCreate_Click(object sender, EventArgs e)
        {
            Random rnd = new();
            var aircraftcarrier = new DrawningAircraftCarrier(rnd.Next(100, 300), rnd.Next(1000, 2000), Color.FromArgb(rnd.Next(0, 256), rnd.Next(0, 256), rnd.Next(0, 256)));
            SetData(aircraftcarrier);
        }
        private void ButtonMove_Click(object sender, EventArgs e)
        {
            string name = ((Button)sender)?.Name ?? string.Empty;
            Direction dir = Direction.None;
            switch (name)
            {
                case "buttonUp":
                    dir = Direction.Up;
                    break;
                case "buttonDown":
                    dir = Direction.Down;
                    break;
                case "buttonLeft":
                    dir = Direction.Left;
                    break;
                case "buttonRight":
                    dir = Direction.Right;
                    break;
            }
            PictureBoxAircraftCarrier.Image = _abstractMap?.MoveObject(dir);
        }
        private void ButtonCreateModif_Click(object sender, EventArgs e)
        {
            Random rnd = new();
            var aircraftcarrier = new DrawningModernAircraftCarrier(rnd.Next(100, 300), rnd.Next(1000, 2000), Color.FromArgb(rnd.Next(0, 256), rnd.Next(0, 256), rnd.Next(0, 256)), Color.FromArgb(rnd.Next(0, 256), rnd.Next(0, 256), rnd.Next(0, 256)), Convert.ToBoolean(rnd.Next(0,2)), Convert.ToBoolean(rnd.Next(0, 2)), Convert.ToBoolean(rnd.Next(0, 2)));
            SetData(aircraftcarrier);
        }
        private void ComboBoxSelectorMap_SelectedIndexChanged(object sender, EventArgs e)
        {
            switch (comboBoxSelectorMap.Text)
            {
                case "Простая карта":
                    _abstractMap = new SimpleMap();
                    break;
                case "Сложная карта":
                    _abstractMap = new ComplexMap();
                    break;
            }
        }
    }
}